/** FONTED.H ********************************************
 *	(c) Perlin Production Co.Ltd. June 1993		*
 *		Bold BIOS Font Editor			*
 * Revisions:						*
 * March 2023	adaptation overhaul to WIOS 5.0		*
 ********************************************************/
#include "wios.h"

#define O_SPEED
#define O_SIZE
/*
 * Bold BIOS font properties
 */
#define	FNT_WDT		6	/* font width  [pixels] */
#define	FNT_HGT		10	/* font height [pixels] */
#define FIRST_CHAR	32	/* first 32 chars are absent in Bold BIOS */
#define	NUM_CHARS	224	/* preprocessor can't multiply compile-time */

extern	char	font[NUM_CHARS][FNT_HGT]; /* ᨢ  㯠묨 ᨬ.*/

extern	int	idx_chr;	/* H ।㥬 ᨬ */

#define PREF_SELCHAR	0	/* character selection dialog on edit	*/
#define PREF_DRAWDESK	1	/* repaint desktop after flashing to OS	*/
#define PREF_AUTOSAVE	2	/* auto-save on exit			*/
#define PREF_LASTLOAD	3	/* load last edited font on start	*/
#define PREF_BMDIRTY	4	/* prompt leaving modified bitmap	*/
#define PREF_FDIRTY	5	/* prompt reloading modified file	*/
#define PREF_PLATFORM	6	/* Vector-06c button names		*/
#define NUM_PREF	7	/* number of preferences		*/

extern char pref[NUM_PREF];	/* persisted preferences */

extern	WINDOW	*DESKTOP;
extern	WINDOW	*MNU_MAIN;
extern	WINDOW	*MNU_FILE;
extern	WINDOW	*MNU_EDIT;
extern	WINDOW	*MNU_FLASH;
extern	WINDOW	*MNU_TOOLS;
extern	WINDOW	*MNU_HELP;
extern	WINDOW	*DLG_EDIT;
extern	WINDOW	*DLG_CODE;
extern	WINDOW	*DLG_OSFONT;
extern	WINDOW	*DLG_INFO;
/* main menu items */
#define	MAIN_FILE	0
#define	MAIN_EDIT	1
#define	MAIN_FLASH	2
#define MAIN_TOOLS	3
#define	MAIN_HELP	4
#define	NUM_MAIN	5
/* <F>ile menu items */
#define	FILE_NEW	0
#define	FILE_OPEN	1
#define	FILE_RELOAD	2
#define	FILE_SAVE	3
#define	FILE_RENAME	4
#define	FILE_EXIT	6
#define	NUM_FILE	7
/* <E>dit menu items */
#define EDIT_NOW	0
#define EDIT_NEG	2
#define EDIT_CLR	3
#define NUM_EDIT	4
/* <Patch> menu items */
#define FLASH_LOAD	0
#define FLASH_SAVE	1
#define FLASH_DESK	3
#define NUM_FLASH	4
/* <Tools> menu items	*/
#define TOOL_PREF	0
#define NUM_TOOL	1
/* <H>elp menu items */
#define	HELP_ABOUT	0
#define	HELP_OSVER	2
#define NUM_HELP	3

#define	BEEP	cputs("\007")

#define	SIZ_FNAME	16	/* allocated filename size */
extern char filename[SIZ_FNAME];/*  䠩	*/
