/** FONTED05.C *******************************************
 *							*
 *	(c) Perlin Production Co.Ltd. June 1993		*
 *		Bold BIOS Font Editor			*
 *							*
 * Abstract:	Help submenu, About dialog, OS version	*
 * Revisions:						*
 * Mar 2023	adaptation overhaul to WIOS 5.0		*
 ********************************************************/
#include "fonted.h"
#include "conio.h"
#include "cpmver.h"

static sh_ver()
{
/*	
#ifndef O_SIZE
*/
	OSVER		ver;
	char		text[MAXX];
	
	osver(&ver);

	sprintf	(text
	, "OS family: %s ver %u.%u"
	, ver.os_name
	, ver.os_hi
	, ver.os_lo
	);
	wn_active(DLG_INFO,1);
	sh_info  (text,0);
	wn_active(DLG_INFO,0);
/*	
#endif	
*/	
}

splash(timeout)
unsigned timeout;
{
	register WINDOW	*this;
	
	if (this = modal(0,32,8))
	{
		sw_border(this, BR_DS);
		sw_fill	(this, WN_CLIENT, BLANK);
		sw_color(this, WN_CLIENT, COLOR_1);
		
	 	wn_set	(this);
		wn_ctx	(this
,"(c) Perlin Production Co.Ltd.\nMay 1993-Aug 2023\nAll rights reserved\n\nBold BIOS Font Editor\nVersion 1.2"
		, 6);
		if (timeout)	delay(timeout);
		else 		{ sh_info(0,0); wn_hide(this); }
		
		wn_destroy(this);
	}
}

MENUSEL mi_help()
{
	register MENUSEL sel;

	switch (sel = wn_list(wn_set(MNU_HELP)))
	{
		case HELP_OSVER: sh_ver(); break;
		case HELP_ABOUT:
			splash(0);
			wn_set(DLG_CODE);
			break;
	}
	wn_hide(MNU_HELP);
	sh_font();
	return sel;
}
